#ifndef WINAPI_INC
#include "winapi.inc"
#endif



//#use "psapi.lib"

#ifndef __CBasicDebugger_defined__
#define __CBasicDebugger_defined__
//FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
//	NULL, GetLastError(), 0, &pszMsg, 0, NULL );


// to do: create custom functions for:
// - GetModuleBaseName
// - EnumProcessModules
// - GetModuleInformation (need MODULEINFO.lpBaseOfDll)

class CBasicDebugger
{
	declare CBasicDebugger();
	declare _CBasicDebugger();
	// call this before debugging :)
	declare virtual SetProcessPath(string szExecutable),BOOL;

	declare virtual StartSession(),BOOL;
	declare virtual WaitForEvents(DWORD dwMilliseconds),BOOL;
	declare virtual StopDebugging(),BOOL;

	declare virtual AttachDebuggerTo(DWORD dwProcessID),BOOL;// save hProcess and hThread in m_pi
	declare virtual DetachDebugger(),BOOL;

	declare virtual GetEntryPoint(void *lpBaseOfDll),DWORD;
	////////////////////////////// debugger events ///////////////////////////
	// notes:
	// 1. You must call FreeHeap for all this strings
	// 2. You must close all handles (hFile,hProcess,hThread)
	// or
	// 1,2 :  call the original method
	declare virtual OnCreateProcess(HANDLE hFile, HANDLE hProcess, HANDLE hThread),BOOL;
	declare virtual OnCreateThread(HANDLE hThread),BOOL;
	declare virtual OnLoadDll(string szDllFullPath, string szDllName, HANDLE hFile, void *lpBaseOfDll),BOOL;
	declare virtual OnUnloadDll(void *BaseOfDll),BOOL;
	declare virtual OnException(BOOL FirstChance, DWORD ExceptionCode, void *ExceptionAddress, CONTEXT ctx),BOOL;
	declare virtual OnDebugString(string szMessage),BOOL; // to do
	declare virtual OnExitThread(DWORD dwExitCode),BOOL;
	declare virtual OnExitProcess(DWORD dwExitCode, HANDLE hProcess, HANDLE hThread),BOOL; // the primary handles
	declare virtual OnRipEvent(),BOOL;

	declare virtual GetApiPointer(string szModule, string szApi, void *ppPtr),BOOL;
	declare virtual GetDllPath(void *ppszDllFullPath, void *ppszDllName),BOOL;
	declare virtual ReadStringFromProcess(void *lpImageName,BOOL isPointer,BOOL bUnicode,int size,void *ppString),BOOL;

	// main variables
	string *m_szExecutable;
	PROCESS_INFORMATION m_pi; // cleaned up in OnExitProcess()
	BOOL m_bAttached; // true if AttachTo secceeded
	DEBUG_EVENT m_de;
	////////////////////////////
	void *ModuleBase;
	void *EntryPoint;
}


#endif
