#ifndef WINAPI_INC
#include "winapi.inc"
#endif

#ifndef LINKEDLIST_INC
#include "LinkedList.inc"
#endif

/*
 using breakpoints

	find pointer in process adress space to any api you need to spy
	insert breakpoint:

	CBreakPointCollection m_breaks;
	m_breaks.SetProcessHandle(my_hProcess);
	// find yor api
	m_breaks.AddBreakpoint(apiptr, _CONST_ENTRY_); //
	// wait for breakpoint exception
	ValidateBreakpoint(exceptionptr)
	GetBreakpoint(exceptionptr,null,&userdata)
	if userdata = _CONST_ENTRY_ : disable it and add new at process [esp] with flag _CONST_RET_ and friend
	if userdata = _CONST_RET_ : remove it
*/


#ifndef __CBreakPointCollection_defined__
#define __CBreakPointCollection_defined__


struct BREAKPOINT_DATA {
	void            *address;  // breakpoint address (in process address space)
	unsigned byte    bOriginal;// original byte from process or breakpoint code
	DWORD            dwFlags;  // any data
	BREAKPOINT_DATA *friend_node;// you can have associated nodes
	void            *userdata; // any data, i.e. static string
	string          *StringData;// duplicated string
}



class CBreakPointCollection
{
	// private
	declare CBreakPointCollection();
	declare _CBreakPointCollection();
	// finds a node in linked list (m_enumpos)
	declare virtual FindBreakpoint(void *address),BOOL;
	declare virtual SetProcessHandle(HANDLE hProcess),BOOL;
	declare virtual AddBreakpoint(void *address,/*out*/opt DWORD dwFlags, /*opt void *userdata, */opt void *friend),BOOL;
	declare virtual RemoveBreakpoint(void *address),BOOL;
	declare virtual RemoveAllBreakpoints();

	declare virtual SetFlags(void *address,DWORD dwFlags),BOOL;
	declare virtual GetFlags(void *address,DWORD *lpdwFlags),BOOL;

	declare virtual SetFriend(void *address,void *friend),BOOL;
	declare virtual GetFriend(void *address,void *ppFriend),BOOL;

	declare virtual SetData(void *address,void *data),BOOL;
	declare virtual GetData(void *address,void *ppData),BOOL;

	declare virtual SetStringData(void *address,string *lpStringData),BOOL;
	declare virtual GetStringData(void *address,void *ppStringData),BOOL;

	// GetBreakpoint - fix me
	declare virtual GetBreakpoint(void *address, /*out*/opt DWORD *lpdwFlags),BOOL;
	declare virtual DisableBreakpoint(void *address),BOOL;
	declare virtual EnableBreakpoint(void *address),BOOL;
	// private
	declare virtual SwapBreakpointBytes(),BOOL;
	declare virtual CleanupBreakpoint(BREAKPOINT_DATA *bp);

	pointer m_bplist;          // linked list (can be null)
	pointer m_enumpos;//         // current node in linked list
	pointer m_curaddr;//         // current breakpoint address
	BREAKPOINT_DATA *m_bpdata;// // pointer to data for current node m_enumpos
	HANDLE m_hProcess;
}


#endif

