#ifndef LINKEDLIST_INC
#define LINKEDLIST_INC

#use "LinkedList.lib"
//#include "LinkedList.inc"

extern pointer ListCreate alias _ListCreate@4(void *data); // data - pointer to static/safe-allocated data
extern pointer ListAdd alias _ListAdd@8(pointer root, void *data);
extern pointer ListAddHead alias _ListAddHead@8(pointer root, void *data);
extern pointer ListInsert alias _ListInsert@8(pointer node, void *data);
extern pointer ListGetData alias _ListGetData@4(pointer node);
extern pointer ListSetData alias _ListSetData@8(pointer node, void *data);
extern pointer ListGetFirst alias _ListGetFirst@8(pointer root, opt void *lpdata=0); // lpdata - pointer to a variable
extern pointer ListGetNext alias _ListGetNext@8(pointer node, opt void *lpdata=0);  // that receives data pointer
extern pointer ListGetPrev alias _ListGetPrev@8(pointer node, opt void *lpdata=0);
extern pointer ListGetLast alias _ListGetLast@8(pointer root, opt void *lpData=0);
extern int     ListEnumFromStart alias _ListEnumFromStart@12(pointer root, void *lpPos, void *lpdata); // ListEnum* - first time set Pos to null or any node
extern int     ListEnumFromEnd   alias _ListEnumFromEnd@12(pointer node, void *lpPos, void *lpdata); // node - any node in list, or list
extern int     ListRemove        alias _ListRemove@8(pointer node, opt int bDelete=0);
extern int     ListRemoveAll     alias _ListRemoveAll@8(pointer node, opt int bDeleteData=false); // node - any node in list, or list
// ListFind - searches for an integer or pointer
extern int     ListFind    alias _ListFind@12(pointer root, void *dataFind, opt void *ppFoundPos=0);// new here!



// special for strings
extern pointer ListCreateString  alias _ListCreateStringA@4(string *lpAstring);
extern pointer ListCreateStringW alias _ListCreateStringW@4(string *lpAstring);
extern pointer ListAddString     alias _ListAddStringA@8(pointer root, string *lpAstring);
extern pointer ListAddStringW    alias _ListAddStringW@8(pointer root, string *lpWstring);
extern int     ListFindString    alias _ListFindStringA@12(pointer root, string *lpFind, opt void *ppFoundPos=0);
extern int     ListFindStringW   alias _ListFindStringW@12(pointer root, string *lpWFind, opt void *ppFoundPos=0);
extern pointer ListInsertString  alias _ListInsertStringA@8(pointer node, string *lpAstring);
extern pointer ListInsertStringW alias _ListInsertStringW@8(pointer node, string *lpWstring);
extern pointer ListReplaceString alias _ListReplaceStringA@8(pointer node, string *lpAstring);
//extern pointer ListReplaceStringW alias _ListReplaceStringW@8(pointer node, string *lpWstring);


// aliased names for every integer data type
extern pointer dwListCreate   alias _ListCreate@4(int data);
extern pointer dwListAdd      alias _ListAdd@8(pointer root, int data);
extern pointer dwListAddHead  alias _ListAddHead@8(pointer root, int data);
extern pointer dwListInsert   alias _ListInsert@8(pointer node, int data); // to do!
extern int     dwListGetData  alias _ListGetData@4(pointer node);
extern pointer dwListGetFirst alias _ListGetFirst@8(pointer root, opt int *lpdata=0); // lpdata - pointer to a variable
extern pointer dwListGetNext  alias _ListGetNext@8(pointer node, opt int *lpdata=0);  // that receives integer
extern pointer dwListGetPrev  alias _ListGetPrev@8(pointer node, opt int *lpdata=0);
extern pointer dwListGetLast  alias _ListGetLast@8(pointer root, opt int *lpData=0);
extern int     dwListEnumFromStart alias _ListEnumFromStart@12(pointer root, void *lpPos, int *lpdata);
extern int     dwListEnumFromEnd   alias _ListEnumFromEnd@12(pointer node, void *lpPos, int *lpdata);
extern int     dwListRemove    alias _ListRemove@8(pointer node, opt int bDelete=0);
extern int     dwListRemoveAll alias _ListRemoveAll@8(pointer node, opt int bDeleteData=false);


#endif
