%include "list.inc"

global _ListRemove@8

_ListRemove@8: ; BOOL ListRemove(llist *node, opt int bDelete=0)
	push esi
	push edi

	%define node esi
	mov  node,[esp+12]
	push node
	call _ListValidate@4           ; if (node is valid) ...
	jz  .quit
	xor  eax,eax

	; -----------------------------------------
	; 1. delete node.data
	; -----------------------------------------
	mov  edx,[node+llist.data]  ; if (node.data = null) skip
	and  edx,edx
	jz  .nodelete
	cmp  dword[esp+16],eax      ; if (bDelete = false) skip
	jz  .nodelete
	delete edx                  ; delete node.data
.nodelete
	xor  eax,eax
	mov  [node+llist.data],eax  ; node.data = null
	; -----------------------------------------
	; 2. node can be root, inside list or last
	; -----------------------------------------
	%define prev esi
	%define node edx
	%define next edi

	mov  node,esi
	mov  prev,[node+llist.prev]
	mov  next,[node+llist.next]

	and  next,next              ; if (NextNode != null) ...
	jnz .isnext
	; -----------------------------------------
	; a. node is last [eax=null, prev<>null, next=null]
	;    or only this node is in list
	; -----------------------------------------
	and  prev,prev              ; if (PrevNode <> null) ...
	jz  .delnode                ; only this node is in list
	mov  [prev+llist.next],eax  ; ... PrevNode.next = null;

.delnode:
	delete node                 ; delete node
	mov  al,1
	jmp .quit

.isnext:
	and  prev,prev              ; if (node.prev != null) ...
	jz .isroot
	; -----------------------------------------
	; b. node is inside list [eax=null, prev<>null, next<>null]
	; -----------------------------------------
	mov  [prev+llist.next],next ; ... PrevNode.next = NextNode ...
	mov  [next+llist.prev],prev ; ... NextNode.prev = PrevNode
	jmp .delnode

.isroot
	; -----------------------------------------
	; c. node is root [eax=null, prev=null, next<>null]
	; -----------------------------------------
	mov  eax,[next+llist.data] ; node.data = next.data
	mov  [node+llist.data],eax
	mov  eax,[next+llist.next] ; node.next = next.next
	mov  [node+llist.next],eax
	; next.next.prev = node ; save edi!
	mov  esi,[next+llist.next]
	and  esi,esi
	jz  .onlytwo
	mov  [esi+llist.prev],node
.onlytwo:
	mov  node,next
	jmp .delnode

.quit
	pop  edi
	pop  esi
	ret  8

