#ifndef WINAPI_INC
#define WINAPI_INC

#define ERROR_INVALID_HANDLE             6 

extern int strlen alias _astrlen(string *src);
extern int strcpy alias _astrcpy(string *dest,string *src);
extern int strcat alias _astrcat(string *dest,string *src);
extern int farcall(/*unsigned int function,*/ ...);

extern int makestruct(void *str, ...);
extern int IIF(int expression, int iftrue,int iffalse);

struct GUID
{
	int x[4];
}
struct CLSID
{
	int x[4];
}
struct IID
{
	int x[4];
}
#define CDDS_SUBITEMPREPAINT 0x30001

// general
#typedef HRESULT     unsigned int
#typedef LPBYTE       pointer
#typedef LPWORD       pointer
#typedef LPDWORD      pointer
#typedef REGSAM       unsigned int
#typedef time_t       unsigned int
#typedef COLORREF     unsigned int
#typedef PVOID        pointer
#typedef LPVOID       pointer
#typedef UINT         unsigned int
#typedef u_int        unsigned int
#typedef WINOLEAPI    unsigned int
#typedef DWORD        unsigned int
#typedef LRESULT      unsigned int
#typedef CLIPFORMAT   unsigned int
#typedef INT_PTR      unsigned int
#typedef UINT_PTR     unsigned int
#typedef DWORD_PTR    unsigned int
#typedef ULONG_PTR    unsigned int
#typedef LONG         int
#typedef u_long       unsigned int
#typedef ULONG        unsigned int
#typedef ULONGLONG    unsigned int64
#typedef LONGLONG     int64
#typedef SHORT        word
#typedef u_short      unsigned word
#typedef CHAR         byte
#typedef u_char       unsigned byte
#typedef UCHAR        unsigned byte
#typedef USHORT       unsigned word
#typedef BOOL         int
#typedef ATOM         word
#typedef WPARAM       unsigned int
#typedef LPARAM       unsigned int
#typedef HINSTANCE    unsigned int
#typedef SIZE_T       unsigned int
#typedef PUINT        pointer
// callbacks
#typedef THREAD_START_ROUTINE unsigned int
#typedef FARPROC      unsigned int
#typedef HOOKPROC     unsigned int
#typedef CALLBACK     unsigned int
#typedef WNDPROC      unsigned int
// handles
#typedef HPEN          unsigned int
#typedef HKEY          unsigned int
#typedef HMODULE       unsigned int
#typedef HHOOK         unsigned int
#typedef HLOCAL        unsigned int
#typedef HRGN          unsigned int
#typedef HDC           unsigned int
#typedef HWND          unsigned int
#typedef HACCEL        unsigned int
#typedef HMENU         unsigned int
#typedef HFONT         unsigned int
#typedef HOLEMENU      unsigned int
#typedef HBITMAP       unsigned int
#typedef HMETAFILEPICT unsigned int
#typedef HENHMETAFILE  unsigned int
#typedef HGLOBAL       unsigned int
#typedef HICON         unsigned int
#typedef HCURSOR       unsigned int
#typedef HANDLE        unsigned int
#typedef HBRUSH        unsigned int
#typedef HGDIOBJ       unsigned int
// strings
#typedef PBYTE         pointer
#typedef WCHAR         unsigned word
#typedef LPTSTR        string
#typedef LPCWSTR       pointer
#typedef LPCSTR        string
#typedef LPSTR         string
#typedef LPWSTR        string
#typedef LPOLESTR      string
#typedef LPCTSTR       string
#typedef LPCOLESTR     string
#typedef OLECHAR       string
#ifdef _UNICODE
	#typedef TCHAR unsigned word
#else
	#typedef TCHAR unsigned byte
#endif

#define MAX_PATH 260

struct NMLISTVIEW {
    NMHDR hdr;
    int iItem;
    int iSubItem;
    UINT uNewState;
    UINT uOldState;
    UINT uChanged;
    POINT ptAction;
    LPARAM lParam;
}

struct LARGE_INTEGER
{
    int64 QuadPart[0];
//  struct {
    DWORD LowPart;
    LONG HighPart;
//  };
}

struct ULARGE_INTEGER
{
    unsigned int64 QuadPart[0];
//  struct {
    DWORD LowPart;
    ULONG HighPart;
//  };
}
struct SYSTEMTIME{
  WORD wYear;
  WORD wMonth;
  WORD wDayOfWeek;
  WORD wDay;
  WORD wHour;
  WORD wMinute;
  WORD wSecond;
  WORD wMilliseconds;
}
struct BITMAP
{
  LONG   bmType;
  LONG   bmWidth;
  LONG   bmHeight;
  LONG   bmWidthBytes;
  WORD   bmPlanes;
  WORD   bmBitsPixel;
  LPVOID *bmBits;
}

struct CREATESTRUCT
{
    LPVOID lpCreateParams;
    HINSTANCE hInstance;
    HMENU hMenu;
    HWND hwndParent;
    int cy;
    int cx;
    int y;
    int x;
    LONG style;
    LPCTSTR *lpszName;
    LPCTSTR *lpszClass;
    DWORD dwExStyle;
}
#DEFINE LF_FACESIZE 32

struct LOGFONT
{ 
  LONG lfHeight; 
  LONG lfWidth; 
  LONG lfEscapement; 
  LONG lfOrientation; 
  LONG lfWeight; 
  BYTE lfItalic; 
  BYTE lfUnderline; 
  BYTE lfStrikeOut; 
  BYTE lfCharSet; 
  BYTE lfOutPrecision; 
  BYTE lfClipPrecision; 
  BYTE lfQuality; 
  BYTE lfPitchAndFamily; 
  TCHAR lfFaceName[LF_FACESIZE]; 
}
struct POINT
{
	int x;
	int y;
}

struct RECT
{
	int left;
	int top;
	int right;
	int bottom;
}
struct WNDCLASS
{
	UINT style;
	UINT lpfnwndproc;
	int cbClsextra;
	int  cbWndExtra;
	HINSTANCE  hInstance;
	HICON hIcon;
	HCURSOR hCursor;
	HBRUSH hbrBackground;
	string *lpszMenuName;
	string *lpszClassName;
}
struct OLEINPLACEFRAMEINFO
{ 
    UINT   cb; 
    BOOL   fMDIApp; 
    HWND   hwndFrame; 
    HACCEL haccel; 
    UINT   cAccelEntries; 
} 
struct MENUITEMINFO
{
  UINT    cbSize;
  UINT    fMask;
  UINT    fType;
  UINT    fState;
  UINT    wID;
  UINT    hSubMenu;
  UINT    hbmpChecked;
  UINT    hbmpUnchecked;
// union
    DWORD   dwItemData [O];
    void    *pItemData [1];
  pointer dwTypeData;
  UINT    cch;
  UINT    hbmpItem;
}

struct SIZE
{
	UINT cx;
	UINT cy;
}
struct POINTL { 
  LONG x; 
  LONG y; 
}
struct POINTF 
{ 
    float x; 
    float y; 
}
struct POINTS // check it
{
  SHORT x; 
  SHORT y; 
}
struct SIZEL
{
	UINT cx;
	UINT cy;
}

struct MSG
{
    HWND hwnd;
    UINT message;
    WPARAM wParam;
    LPARAM lParam;
    DWORD time;
    POINT pt;
}

struct WINDOWPOS{
    HWND hwnd;
    HWND hwndInsertAfter;
    int x;
    int y;
    int cx;
    int cy;
    UINT flags;
}

struct EVENTMSG
{
    UINT message;
    UINT paramL;
    UINT paramH;
    DWORD time;
    HWND hwnd;
}
struct PAINTSTRUCT
{ 
  HDC  hdc;
  BOOL fErase;
  RECT rcPaint;
  BOOL fRestore;
  BOOL fIncUpdate;
  BYTE rgbReserved[32]; 
}
struct BITMAPINFOHEADER,2
{
  DWORD  biSize; 
  LONG   biWidth; 
  LONG   biHeight; 
  WORD   biPlanes; 
  WORD   biBitCount; 
  DWORD  biCompression; 
  DWORD  biSizeImage; 
  LONG   biXPelsPerMeter; 
  LONG   biYPelsPerMeter; 
  DWORD  biClrUsed; 
  DWORD  biClrImportant; 
}
// biCompression
#define BI_RGB       0
#define BI_RLE8      1
#define BI_RLE4      2
#define BI_BITFIELDS 3
#define BI_JPEG      4
#define BI_PNG       5

struct RGBQUAD,1
{
	unsigned byte rgbBlue;
	unsigned byte rgbGreen;
	unsigned byte rgbRed;
	unsigned byte rgbReserved;
}
struct BITMAPINFO
{
  BITMAPINFOHEADER bmiHeader; 
  RGBQUAD          bmiColors[1]; 
}
struct PREVENT_MEDIA_REMOVAL,1
{
  byte PreventMediaRemoval;
}
struct SECURITY_ATTRIBUTES
{
	DWORD   nLength;
	LPVOID *lpSecurityDescriptor;
	BOOL    bInheritHandle;
}
struct STARTUPINFO
{
	DWORD  cb;
	LPTSTR *lpReserved;
	LPTSTR *lpDesktop;
	LPTSTR *lpTitle;
	DWORD  dwX;
	DWORD  dwY;
	DWORD  dwXSize;
	DWORD  dwYSize;
	DWORD  dwXCountChars;
	DWORD  dwYCountChars;
	DWORD  dwFillAttribute;
	DWORD  dwFlags;
	word   wShowWindow;
	word   cbReserved2;
	byte  *lpReserved2;
	HANDLE hStdInput;
	HANDLE hStdOutput;
	HANDLE hStdError;
}
struct PROCESS_INFORMATION
{
	HANDLE hProcess;
	HANDLE hThread;
	DWORD dwProcessId;
	DWORD dwThreadId;
}
#define ERROR_SUCCESS 0

#define CS_GLOBALCLASS   0x4000
#define WM_USER 0x400
#define WM_DESTROY  2
#define WM_GETFONT 0x31
#define WM_SETFONT 0x30
#define WM_NCCREATE 0x81
#define WM_LBUTTONDOWN 0x201
#define WM_LBUTTONUP 0x202
#define WM_CTLCOLORSTATIC 0x138
#define WM_MOUSEMOVE  0x200
#define WM_NOTIFY 0x4E
#define WM_CREATE   1
#define WM_GETTEXT  0xD
#define WM_CLOSE    0x10
#define WM_SETCURSOR 0x20
#define WM_SIZE     5
#define WM_SETREDRAW  0xB
#define WM_PAINT  0xF

//#define NM_CLICK -2

#define BLACK_BRUSH              4
#define INVALID_HANDLE_VALUE 0xFFFFFFFF

#define SM_CXSCREEN  0
#define SM_CYSCREEN  1
#define WS_OVERLAPPEDWINDOW  0xCF0000
#define WS_VISIBLE  0x10000000
#define CW_USEDEFAULT  0x80000000
CONST NO_ERROR = 0;
CONST SW_HIDE = 0;
CONST SW_SHOW = 5;
CONST SW_MAXIMIZE = 3;
CONST SW_MINIMIZE = 6;
CONST SW_RESTORE = 9;
CONST SW_SHOWDEFAULT = 10;
CONST SW_SHOWMAXIMIZED = 3;
CONST SW_SHOWMINIMIZED = 2;
CONST SW_SHOWMINNOACTIVE = 7;
CONST SW_SHOWNA = 8;
CONST SW_SHOWNOACTIVATE = 4;
CONST SW_SHOWNORMAL = 1;


#define LR_LOADFROMFILE  0x10
#define IMAGE_BITMAP 0
#define IMAGE_ICON 1
#define IMAGE_CURSOR 2
#define IMAGE_ENHMETAFILE 3
#define SWP_NOMOVE  2

#ifndef exetypeconsole
extern _hinstance as HINSTANCE;
#endif

//import int IsEqualGUID(GUID *riid1, GUID *riid2); function in extras.src

//crt cdecl imports
extern int cdecl _beginthread(...);
extern int cdecl __GetMainArgs(int *argc, string *argv, string *environ, opt int unknown=0);
extern int printf(...);
extern int sprintf(string *destination,...);
extern int cdecl memset(void *destination,byte fill_with,int count);
extern int cdecl memcpy(void *destination,void *source,int size);
extern int cdecl memcmp(void *memory1,void *memory2,int size);
extern int cdecl wcscmp(WCHAR *str1,WCHAR *str2);
extern pointer cdecl itoa alias _itoa(int integer, string *buffer, int base); // returns buffer
extern int fopen(...);
extern int fwrite(...);
extern int putc(...);
extern int msize alias _msize(...);
extern int fclose(...);
extern int system(...);
extern int cdecl strncmp(string *s1,string *s2,int count);
extern pointer strchr(string *sz, byte b);
extern int atoi(...);
extern int strncpy(string *dst,string *src, int size);
extern void cdecl malloc(int memsize);
extern int  cdecl free(void *memory);
extern pointer cdecl strstr(string *find_in, string *find_first_what);
extern pointer cdecl strrchr(string *find_in, byte find_last_what);
extern pointer ctime(...);
extern byte getch alias _getch();

declare import, InitializeCriticalSection(CRITICAL_SECTION *lpCriticalSection);
declare import, DeleteCriticalSection(CRITICAL_SECTION *lpCriticalSection);
declare import, EnterCriticalSection(CRITICAL_SECTION *lpCriticalSection);
declare import, LeaveCriticalSection(CRITICAL_SECTION *lpCriticalSection);

struct CRITICAL_SECTION { // hacked!
	byte x[24];
}

//unsorted
declare import, OutputDebugString alias OutputDebugStringA(LPCTSTR *lpOutputString);
declare import, OutputDebugStringW(LPCTSTR *lpOutputString);
declare import, GetUserName alias GetUserNameA(LPTSTR *lpBuffer, DWORD *nSize),BOOL;
declare import, GetUserNameW(LPTSTR *lpBuffer, DWORD *nSize),BOOL;
declare import, FormatMessage alias FormatMessageA(DWORD dwFlags, LPCVOID *lpSource, DWORD dwMessageId, DWORD dwLanguageId, LPTSTR *lpBuffer, DWORD nSize, void* Arguments),DWORD;
declare import, FormatMessageW(DWORD dwFlags, LPCVOID *lpSource, DWORD dwMessageId, DWORD dwLanguageId, LPTSTR *lpBuffer, DWORD nSize, void* Arguments),DWORD;
#define FORMAT_MESSAGE_ALLOCATE_BUFFER 0x00000100
#define FORMAT_MESSAGE_IGNORE_INSERTS  0x00000200
#define FORMAT_MESSAGE_FROM_STRING     0x00000400
#define FORMAT_MESSAGE_FROM_HMODULE    0x00000800
#define FORMAT_MESSAGE_FROM_SYSTEM     0x00001000
#define FORMAT_MESSAGE_ARGUMENT_ARRAY  0x00002000
#define FORMAT_MESSAGE_MAX_WIDTH_MASK  0x000000FF

declare import, MessageBeep(UINT uType),BOOL;
declare import, LoadLibrary alias LoadLibraryA(LPCTSTR *lpFileName),HMODULE;
declare import, LoadLibraryW(LPWSTR *lpFileName),HMODULE;
declare import, FreeLibrary(HMODULE hModule),BOOL;

//file
declare import, GetModuleFileName alias GetModuleFileNameA(HMODULE hModule,LPTSTR *lpFilename,DWORD nSize),DWORD;
declare import, MoveFile alias MoveFileA(LPCTSTR *lpExistingFileName,LPCTSTR *lpNewFileName),BOOL;
declare import, MoveFileW(LPWSTR *lpExistingFileName,LPWSTR *lpNewFileName),BOOL;
declare import, CopyFileA(LPCTSTR *lpExistingFileName, LPCTSTR *lpNewFileName,opt BOOL bFailIfExists=false),BOOL;
declare import, CopyFileW(LPWSTR *lpExistingFileName, LPWSTR *lpNewFileName,opt BOOL bFailIfExists=false),BOOL;



//console
#typedef COORD int
declare import, AllocConsole(),BOOL;
extern int SetConsoleTitle alias SetConsoleTitleA(string *title);
declare import, GetConsoleWindow(),HWND;
declare import, GetConsoleScreenBufferInfo(HANDLE hConsoleOutput,  CONSOLE_SCREEN_BUFFER_INFO *lpConsoleScreenBufferInfo),BOOL;
declare import, SetConsoleScreenBufferSize(HANDLE hConsoleOutput, COORD dwSize),BOOL;
declare import, SetConsoleWindowInfo(HANDLE hConsoleOutput, BOOL bAbsolute, SMALL_RECT *lpConsoleWindow),BOOL;
declare import, SetConsoleTextAttribute(HANDLE hConsoleOutput, WORD wAttributes),BOOL;




struct SMALL_RECT {
  SHORT Left;
  SHORT Top;
  SHORT Right;
  SHORT Bottom;
}

struct CONSOLE_SCREEN_BUFFER_INFO{
  COORD dwSize;
  COORD dwCursorPosition;
  WORD wAttributes;
  SMALL_RECT srWindow;
  COORD dwMaximumWindowSize;
}

//string
import int lstrlenW(WCHAR *lpwsz);
import int lstrcpyW(WCHAR *dest, WCHAR *src);
import int lstrcmpi(LPCTSTR *lpString1,LPCTSTR *lpString2);
declare import, MultiByteToWideChar(UINT CodePage, DWORD dwFlags,LPCSTR *lpMultiByteStr,int cbMultiByte,LPWSTR *lpWideCharStr,int cchWideChar),int;
declare import, GetCommandLine alias GetCommandLineA(),pointer;
declare import, GetCommandLineW(),pointer;
declare import, GetSystemDirectory alias GetSystemDirectoryA(LPTSTR *lpBuffer, UINT uSize),UINT;
declare import, PathGetArgs alias PathGetArgsA(LPCTSTR *pszPath),LPTSTR;
declare import, PathGetArgsW(LPCWSTR *pszPath),LPWSTR;
declare import, PathUnquoteSpaces alias PathUnquoteSpacesA(LPTSTR *lpsz);
declare import, PathQuoteSpacesW(LPWSTR *lpsz);
declare import, PathUnquoteSpacesW(LPWSTR *lpsz);
declare import, PathRenameExtension alias PathRenameExtensionA(LPTSTR *pszPath,LPCTSTR *pszExt),BOOL;
declare import, PathRenameExtensionW(LPWSTR *pszPath,LPWSTR *pszExt),BOOL;
declare import, PathRemoveFileSpec alias PathRemoveFileSpecA(LPTSTR *pszPath),BOOL;
declare import, PathRemoveFileSpecW(LPWSTR *pszPath),BOOL;
declare import, PathRemoveArgs alias PathRemoveArgsA(LPTSTR *pszPath);
declare import, PathRemoveArgsW(LPWSTR *pszPath);

//memory
declare import, LocalAlloc(UINT uFlags, SIZE_T dwBytes),HLOCAL;
declare import, LocalSize(HGLOBAL hMem),SIZE_T;
declare import, LocalFree(HLOCAL hMem),HLOCAL;
declare import, GlobalAlloc(UINT uFlags, SIZE_T dwBytes),HGLOBAL;
declare import, GlobalSize(HGLOBAL hMem),SIZE_T;
declare import, GlobalFree(HGLOBAL hMem),HGLOBAL;
declare import, VirtualAllocEx(HANDLE hProcess, LPVOID lpAddress, SIZE_T dwSize, DWORD flAllocationType, DWORD flProtect),LPVOID;
declare import, VirtualFreeEx(HANDLE hProcess, LPVOID lpAddress, SIZE_T dwSize, DWORD dwFreeType),BOOL;

CONST GMEM_FIXED          = 0;
CONST GMEM_ZEROINIT       = 0x40;
CONST MEM_COMMIT          = 0x1000;
CONST GMEM_MOVEABLE       = 0x2;
CONST GMEM_NOCOMPACT      = 0x0010;
CONST GMEM_NODISCARD      = 0x0020;
CONST GMEM_MODIFY         = 0x0080;
CONST GMEM_DISCARDABLE    = 0x0100;
CONST GMEM_NOT_BANKED     = 0x1000;
CONST GMEM_SHARE          = 0x2000;
CONST GMEM_DDESHARE       = 0x2000;
CONST GMEM_NOTIFY         = 0x4000;
CONST GMEM_LOWER          = 0x1000;
CONST GMEM_VALID_FLAGS    = 0x7F72;
CONST GMEM_INVALID_HANDLE = 0x8000;

CONST MEM_FREE     = 0x10000;
CONST MEM_IMAGE    = 0x1000000;
CONST MEM_MAPPED   = 0x40000;
CONST MEM_PHYSICAL = 0x400000;
CONST MEM_PRIVATE  = 0x20000;
CONST MEM_RELEASE  = 0x8000;
CONST MEM_RESERVE  = 0x2000;
CONST MEM_RESET    = 0x80000;
CONST MEM_TOP_DOWN = 0x100000;
CONST MEM_WRITE_WATCH = 0x200000;

Const PAGE_READONLY    = 0x2;
Const PAGE_READWRITE   = 0x4;
Const PAGE_WRITECOPY   = 0x8;
Const PAGE_EXECUTE_READ   = 0x20;
Const PAGE_EXECUTE_READWRITE = 0x40;

declare import, WriteProcessMemory(HANDLE hProcess, LPVOID *lpBaseAddress, LPCVOID *lpBuffer, SIZE_T nSize, SIZE_T *lpNumberOfBytesWritten),BOOL;
declare import, ReadProcessMemory(HANDLE hProcess,LPCVOID *lpBaseAddress,LPVOID *lpBuffer,SIZE_T nSize,SIZE_T *lpNumberOfBytesRead),BOOL;

//registry
#define HKEY_CLASSES_ROOT 0x80000000
#define HKEY_CURRENT_CONFIG 0x80000005
#define HKEY_CURRENT_USER 0x80000001
#define HKEY_LOCAL_MACHINE 0x80000002
#define HKEY_DYN_DATA 0x80000006
declare import, SHGetValue alias SHGetValueA(HKEY hkey,LPCTSTR *pszSubKey,LPCTSTR *pszValue,DWORD *pdwType,VOID *pvData, DWORD *pcbData),DWORD;
declare import, SHSetValue alias SHSetValueA(HKEY hkey,LPCTSTR *pszSubKey,LPCTSTR *pszValue,DWORD dwType,LPCVOID *pvData,DWORD cbData),DWORD;
declare import, RegOpenKeyEx alias RegOpenKeyExA(HKEY hKey, LPCTSTR  *lpSubKey, DWORD ulOptions, REGSAM samDesired, PHKEY *phkResult),LONG;
declare import, RegQueryValueEx alias RegQueryValueExA(HKEY hKey, LPCTSTR *lpValueName, LPDWORD *lpReserved, LPDWORD *lpType, LPBYTE  *lpData, LPDWORD *lpcbData),LONG;
declare import, RegSetValueEx alias RegSetValueExA(HKEY hKey, LPCTSTR *lpValueName, DWORD Reserved, DWORD dwType, BYTE *lpData, DWORD cbData),LONG;
declare import, RegCloseKey(HKEY hKey),LONG;
declare import, RegCreateKeyEx alias RegCreateKeyExA(HKEY hKey, LPCTSTR *lpSubKey, DWORD Reserved, LPTSTR *lpClass, DWORD dwOptions, REGSAM samDesired, LPSECURITY_ATTRIBUTES *lpSecurityAttributes, PHKEY *phkResult, LPDWORD *lpdwDisposition),LONG;
declare import, RegDeleteKey alias RegDeleteKeyA(HKEY hKey, LPCTSTR *lpSubKey),LONG;

#define REG_SZ 1
#define REG_OPTION_NON_VOLATILE 0
#define KEY_ALL_ACCESS 0xF003F

//hook
declare import, SetWindowsHookEx(int idHook, HOOKPROC lpfn, HINSTANCE hMod, DWORD dwThreadId),HHOOK;
declare import, UnhookWindowsHookEx(HHOOK hhk),BOOL;
declare import, CallNextHookEx(HHOOK hhk,int nCode, WPARAM wParam, LPARAM lParam),LRESULT;

#define WH_CALLWNDPROC      4 // CallWndProc
#define WH_CALLWNDPROCRET  12 // CallWndRetProc
#define WH_CBT              5 // CBTProc
#define WH_DEBUG            9 // DebugProc
#define WH_FOREGROUNDIDLE  11 // ForegroundIdleProc
#define WH_GETMESSAGE       3 // GetMsgProc
#define WH_JOURNALPLAYBACK  1 // JournalPlaybackProc
#define WH_JOURNALRECORD    0 // JournalRecordProc
#define WH_KEYBOARD         2 // KeyboardProc
#define WH_KEYBOARD_LL     13 // LowLevelKeyboardProc
#define WH_MOUSE            7 // MouseProc
#define WH_MOUSE_LL        14 // LowLevelMouseProc
#define WH_MSGFILTER       -1 // MessageProc
#define WH_SHELL           10 // ShellProc
#define WH_SYSMSGFILTER     6 // SysMsgProc
//
#define HC_ACTION  0
#define HC_GETNEXT  1
#define HC_NOREMOVE  3
#define HC_NOREM  HC_NOREMOVE
#define HC_SKIP  2
#define HC_SYSMODALOFF  5
#define HC_SYSMODALON  4
//
#define CHILDID_SELF  0
//
#define HCBT_ACTIVATE  5
#define HCBT_CLICKSKIPPED  6
#define HCBT_CREATEWND  3
#define HCBT_DESTROYWND  4
#define HCBT_KEYSKIPPED  7
#define HCBT_MINMAX  1
#define HCBT_MOVESIZE  0
#define HCBT_QS  2
#define HCBT_SETFOCUS  9
#define HCBT_SYSCOMMAND  8
//
#define MSGF_DDEMGR  0x8001
#define MSGF_DIALOGBOX  0
#define MSGF_MAINLOOP 8
#define MSGF_MAX  8
#define MSGF_MENU  2
#define MSGF_MESSAGEBOX  1
#define MSGF_MOVE  3
#define MSGF_NEXTWINDOW  6
#define MSGF_SCROLLBAR  5
#define MSGF_SIZE  4
#define MSGF_USER  4096
//
#define HSHELL_ACCESSIBILITYSTATE  11
#define HSHELL_ACTIVATESHELLWINDOW  3
#define HSHELL_APPCOMMAND       12
#define HSHELL_GETMINRECT       5
#define HSHELL_LANGUAGE         8
#define HSHELL_REDRAW           6
#define HSHELL_TASKMAN          7
#define HSHELL_WINDOWACTIVATED  4
#define HSHELL_WINDOWCREATED    1
#define HSHELL_WINDOWDESTROYED  2
#define HSHELL_WINDOWREPLACED   13
//
#define ACCESS_STICKYKEYS  0x1
#define ACCESS_FILTERKEYS  0x2
#define ACCESS_MOUSEKEYS  0x3

struct CWPSTRUCT
{
    LPARAM lParam;
    WPARAM wParam;
    UINT message;
    HWND hwnd;
}
struct CWPRETSTRUCT
{
    LRESULT lResult;
    LPARAM lParam;
    WPARAM wParam;
    UINT message;
    HWND hwnd;
} 
struct CBTACTIVATESTRUCT
{
    BOOL fMouse;
    HWND hWndActive;
}
struct MOUSEHOOKSTRUCT
{
    POINT pt;
    HWND hwnd;
    UINT wHitTestCode;
    ULONG_PTR dwExtraInfo;
}
struct CBT_CREATEWND
{
    CREATESTRUCT *lpcs;
    HWND hwndInsertAfter;
}
struct DEBUGHOOKINFO
{
    DWORD idThread;
    DWORD idThreadInstaller;
    LPARAM lParam;
    WPARAM wParam;
    int code;
}
struct KBDLLHOOKSTRUCT
{
    DWORD vkCode;
    DWORD scanCode;
    DWORD flags;
    DWORD time;
    ULONG_PTR dwExtraInfo;
}
struct MSLLHOOKSTRUCT
{
    POINT pt;
    DWORD mouseData;
    DWORD flags;
    DWORD time;
    ULONG_PTR dwExtraInfo;
}
//font
declare import, CreateFontIndirect alias CreateFontIndirectA(LOGFONT *lplf),HFONT;

//menu
declare import, GetSubMenu(HMENU hMenu, int nPos),HMENU;
declare import, AppendMenu alias AppendMenuA(HMENU hMenu, UINT uFlags, UINT_PTR uIDNewItem, LPCTSTR *lpNewItem),BOOL;
declare import, SetMenu(HWND hWnd, HMENU hMenu),BOOL;
declare import, RemoveMenu(HMENU hMenu, UINT uPosition, UINT uFlags),BOOL;
declare import, DrawMenuBar(HWND hWnd),BOOL;

//windows
declare import, GetDC(HWND hWnd),HDC;
declare import, GetWindowDC(HWND hWnd),HDC;
declare import, DrawIcon(HDC hDC,int X,int Y,HICON hIcon),BOOL;
declare import, DrawIconEx(HDC hdc,int xLeft,int yTop,HICON hIcon,int cxWidth,int cyWidth,UINT istepIfAniCur,HBRUSH hbrFlickerFreeDraw,UINT diFlags),BOOL;
#define DI_MASK         0x0001
#define DI_IMAGE        0x0002
#define DI_NORMAL       0x0003
#define DI_COMPAT       0x0004
#define DI_DEFAULTSIZE  0x0008
#define DI_NOMIRROR     0x0010
import int MessageBoxA(HWND hwnd, string *body, string *caption, opt int flags);
import int _MessageBox alias MessageBoxA(HWND hwnd, string *body, string *caption, opt int flags);
#define MB_OK 0
declare import, EnableWindow(HWND hWnd,BOOL bEnable),BOOL;
declare import, SetDlgItemText alias SetDlgItemTextA(HWND hDlg,int nIDDlgItem,LPCTSTR *lpString),BOOL;
declare import, GetClassName alias GetClassNameA(HWND hWnd,LPTSTR *lpClassName,int nMaxCount),int;
declare import, SetTextColor(HDC hdc, COLORREF crColor),COLORREF;
declare import, GetParent(HWND hWnd),HWND;
declare import, CallWindowProc alias CallWindowProcA(WNDPROC lpPrevWndFunc,HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam),LRESULT;
declare import, PtInRect(RECT *lprc, POINT *pt),BOOL;
declare import, ClientToScreen(HWND hWnd, POINT *lpPoint),BOOL;
declare import, InvalidateRect(HWND hWnd, RECT *lpRect, BOOL bErase),BOOL;
declare import, SetWindowText alias SetWindowTextA(HWND hWnd, LPCTSTR *lpString),BOOL;
declare import, SetWindowLong alias SetWindowLongA(HWND hWnd, int nIndex,LONG dwNewLong),LONG;
declare import, SetCursor(HCURSOR hCursor),HCURSOR;
declare import, GetCapture(),HWND;
declare import, SetCapture(HWND hWnd),HWND;
declare import, ReleaseCapture(),BOOL;
declare import, GetDlgItem(HWND hDlg,int nIDDlgItem),HWND;
declare import, CopyRect(RECT *lprcDst, RECT *lprcSrc),BOOL;
declare import, GetClientRect(HWND hWnd, RECT *lpRect),BOOL;
declare import, GetMenu(HWND hWnd),HMENU;
declare import, AdjustWindowRect(RECT *lpRect, DWORD dwStyle, BOOL bMenu),BOOL;
declare import, RegisterClass alias RegisterClassA(WNDCLASS *lpWndClass),ATOM;
declare import,LoadIcon alias LoadIconA(opt HINSTANCE hInstance,LPCSTR *lpIconName),HICON;
Declare import, LoadCursor alias LoadCursorA(HINSTANCE hInstance, LPCTSTR *lpCursorName),HCURSOR;
const IDC_ARROW=32512;
const IDC_IBEAM=32513;
const IDC_WAIT=32514;
const IDC_CROSS=32515;
const IDC_UPARROW=32516;
const IDC_SIZE=32640;
const IDC_ICON=32641;
const IDC_SIZENWSE=32642;
const IDC_SIZENESW=32643;
const IDC_SIZEWE=32644;
const IDC_SIZENS=32645;
const IDC_SIZEALL=32646;
const IDC_NO=32648;
const IDC_HAND=32649;
const IDC_APPSTARTING=32650;
const IDC_HELP=32651;

Declare import, CreateSolidBrush(COLORREF crColor),HBRUSH;
Declare import, DefWindowProc alias DefWindowProcA(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam),LRESULT;
Declare import, GetProp alias GetPropA(HWND hwnd, LPCTSTR *lpString),HANDLE;
Declare import, RemoveProp alias RemovePropA(HWND hwnd, LPCTSTR *lpString),HANDLE;
Declare import, SetProp alias SetPropA(HWND hwnd, LPCTSTR *lpString, void hData),BOOL;
Declare import, GetStockObject(int fnObject),HGDIOBJ;
declare import, IsWindowVisible(HWND hwnd),BOOL;
declare import, CreateCompatibleDC(HDC hdc),HDC;
declare import, CreateCompatibleBitmap(HDC hdc,int nWidth,int nHeight),HBITMAP;
declare import, GetSystemMetrics(int nIndex),int;
declare import, SelectObject(HDC hdc, HGDIOBJ hgdiobj),HGDIOBJ;
declare import, DeleteObject(HGDIOBJ hObject),BOOL;
declare import, DeleteDC(HDC hdc),BOOL;

declare import, GetDriveType alias GetDriveTypeA(LPCTSTR *lpRootPathName),UINT;
#define DRIVE_REMOVABLE  2
#define DRIVE_CDROM      5
declare import, CloseHandle(HANDLE hObject),BOOL;
import int Sleep(DWORD ms);
extern int wsprintf alias wsprintfA(...);
import int GetLastError();
declare import, EnumChildWindows(HWND hWndParent, void lpEnumFunc, LPARAM lParam),BOOL;
declare import, SendMessage alias SendMessageA(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam),LRESULT;
declare import, FindWindowEx alias FindWindowExA(HWND hwndParent,HWND hwndChildAfter,LPCTSTR *lpszClass,LPCTSTR *lpszWindow),HWND;
declare import, ShowWindow(HWND hWnd, int nCmdShow),BOOL;
declare import, UpdateWindow(HWND hWnd),BOOL;
declare import, ReleaseDC(HWND hWnd, HDC hdc),int;
declare import, DestroyWindow(HWND hWnd),BOOL;
declare import, BeginPaint(HWND hwnd, PAINTSTRUCT *lpPaint),HDC;
declare import, EndPaint(HWND hwnd, PAINTSTRUCT *lpPaint),BOOL;
declare import, GetObject alias GetObjectA(HGDIOBJ hgdiobj, int cbBuffer, LPVOID *lpvObject),int;
declare import, GetWindowRect(HWND hWnd,RECT *lpRect),BOOL;
declare import, GetWindowLong alias GetWindowLongA(HWND hWnd,int nIndex),LONG;
CONST GWL_EXSTYLE        = -20;
CONST GWL_STYLE          = -16;
CONST GWL_WNDPROC        = -4;
CONST GWL_HINSTANCE      = -6;
CONST GWL_ID             = -12;
CONST GWL_HWNDPARENT     = -8;
CONST GWL_USERDATA       = -21;
CONST DWL_DLGPROC        = 4;
CONST DWL_MSGRESULT      = 0;
CONST DWL_USER           = 8;
declare import, SetStretchBltMode(HDC hdc, int iStretchMode),int;
//iStretchMode
#define STRETCH_ANDSCANS    1
#define STRETCH_ORSCANS     2
#define STRETCH_DELETESCANS 3
#define STRETCH_HALFTONE    4
declare import, PaintDesktop(HDC hdc),BOOL;
declare import, GetPixel(HDC hdc, int nXPos, int nYPos),COLORREF;
declare import, WaitForSingleObject(HANDLE hHandle,DWORD dwMilliseconds),DWORD;
#define INFINITE       0xFFFFFFFF
#define WAIT_ABANDONED 0x00000080
#define WAIT_OBJECT_0  0x00000000
#define WAIT_TIMEOUT   0x00000102

declare import, LoadImage alias LoadImageA(
	HINSTANCE hinst,
    LPCTSTR *lpszName,
    UINT uType,
    int cxDesired,
    int cyDesired,
    UINT fuLoad),HANDLE;

declare import, SetWindowPos(HWND hWnd, HWND hWndInsertAfter, int X, int Y, int cx, int cy, UINT uFlags),BOOL;

declare import, CreateWindowEx alias CreateWindowExA(
    DWORD dwExStyle,
    LPCTSTR *lpClassName,
    LPCTSTR *lpWindowName,
    DWORD dwStyle,
    int x,
    int y,
    int nWidth,
    int nHeight,
    HWND hWndParent,
    HMENU hMenu,
    HINSTANCE hInstance,
    LPVOID lpParam
),HWND;

declare import, FillRect(
  HDC hDC,           // handle to DC
  RECT *lprc,  // rectangle
  HBRUSH hbr         // handle to brush
),int;
CONST WHITE_BRUSH = 0;

declare import, TextOut alias TextOutA(
  HDC hdc,           // handle to DC
  int nXStart,       // x-coordinate of starting position
  int nYStart,       // y-coordinate of starting position
  LPCTSTR *lpString,  // character string
  int cbString       // number of characters
),BOOL;

declare import, BitBlt(
  HDC hdcDest, // handle to destination DC
  int nXDest,  // x-coord of destination upper-left corner
  int nYDest,  // y-coord of destination upper-left corner
  int nWidth,  // width of destination rectangle
  int nHeight, // height of destination rectangle
  HDC hdcSrc,  // handle to source DC
  int nXSrc,   // x-coordinate of source upper-left corner
  int nYSrc,   // y-coordinate of source upper-left corner
  DWORD dwRop  // raster operation code
),BOOL;

declare import, StretchBlt(
  HDC hdcDest,      // handle to destination DC
  int nXOriginDest, // x-coord of destination upper-left corner
  int nYOriginDest, // y-coord of destination upper-left corner
  int nWidthDest,   // width of destination rectangle
  int nHeightDest,  // height of destination rectangle
  HDC hdcSrc,       // handle to source DC
  int nXOriginSrc,  // x-coord of source upper-left corner
  int nYOriginSrc,  // y-coord of source upper-left corner
  int nWidthSrc,    // width of source rectangle
  int nHeightSrc,   // height of source rectangle
  DWORD dwRop       // raster operation code
),BOOL;

#define SRCCOPY     0x00CC0020 //dwRop
#define SRCPAINT    0x00EE0086
#define SRCAND      0x008800C6
#define SRCINVERT   0x00660046
#define SRCERASE    0x00440328
#define NOTSRCCOPY  0x00330008
#define NOTSRCERASE 0x001100A6
#define MERGECOPY   0x00C000CA
#define MERGEPAINT  0x00BB0226
#define PATCOPY     0x00F00021
#define PATPAINT    0x00FB0A09
#define PATINVERT   0x005A0049
#define DSTINVERT   0x00550009
#define BLACKNESS   0x00000042
#define WHITENESS   0x00FF0062

declare import, PlgBlt(
  HDC hdcDest,          // handle to destination DC
  POINT *lpPoint,       // destination vertices
  HDC hdcSrc,           // handle to source DC
  int nXSrc,            // x-coord of source upper-left corner
  int nYSrc,            // y-coord of source upper-left corner
  int nWidth,           // width of source rectangle
  int nHeight,          // height of source rectangle
  opt HBITMAP hbmMask,  // handle to bitmask
  int xMask,            // x-coord of bitmask upper-left corner
  int yMask             // y-coord of bitmask upper-left corner
),BOOL;

declare import, GetDIBits(
  HDC hdc,           // handle to DC
  HBITMAP hbmp,      // handle to bitmap
  UINT uStartScan,   // first scan line to set
  UINT cScanLines,   // number of scan lines to copy
  VOID *lpvBits,     // array for bitmap bits
  BITMAPINFO *lpbi,  // bitmap data buffer
  UINT uUsage        // RGB or palette index
),int;
// uUsage
#define DIB_RGB_COLORS  0
#define DIB_PAL_COLORS  1

declare import, CreateFile alias CreateFileA(
  LPCTSTR *lpFileName,
  DWORD dwDesiredAccess,
  DWORD dwShareMode,
  SECURITY_ATTRIBUTES *lpSecurityAttributes,
  DWORD dwCreationDisposition,
  DWORD dwFlagsAndAttributes,
  HANDLE hTemplateFile
),HANDLE;
#define GENERIC_READ  0x80000000
#define GENERIC_WRITE  0x40000000
#define OPEN_EXISTING  3
#define FILE_SHARE_READ  0x1
#define FILE_SHARE_WRITE  0x2

declare import, DeviceIoControl(
  HANDLE hDevice,
  DWORD dwIoControlCode,
  LPVOID *lpInBuffer,
  DWORD nInBufferSize,
  VOID *lpOutBuffer,
  DWORD nOutBufferSize,
  DWORD *lpBytesReturned,
  OVERLAPPED *lpOverlapped
),BOOL;
#define IOCTL_STORAGE_MEDIA_REMOVAL  0x002D4804
#define IOCTL_STORAGE_EJECT_MEDIA  0x002D4808
#define FSCTL_LOCK_VOLUME  0x00090018
#define FSCTL_DISMOUNT_VOLUME  0x00090020

//process
declare import, GetHandleInformation(HANDLE hObject, DWORD *lpdwFlags),BOOL;
declare import, IsDebuggerPresent(),BOOL;
declare import, GetCurrentProcess(),HANDLE;
declare import, EnumProcessModules(HANDLE hProcess, HMODULE* lphModule, DWORD cb, LPDWORD *lpcbNeeded),BOOL;
declare import, GetModuleBaseName alias GetModuleBaseNameA(HANDLE hProcess, HMODULE hModule, LPTSTR *lpBaseName, DWORD nSize),DWORD;
declare import, GetStdHandle(DWORD nStdHandle),HANDLE;
Const STD_INPUT_HANDLE = -10;
Const STD_OUTPUT_HANDLE = -11;
Const STD_ERROR_HANDLE = -12;

declare import, DuplicateHandle(
  HANDLE hSourceProcessHandle,
  HANDLE hSourceHandle,
  HANDLE hTargetProcessHandle,
  LPHANDLE *lpTargetHandle,
  DWORD dwDesiredAccess,
  BOOL bInheritHandle,
  DWORD dwOptions
),BOOL;
//dwOptions (dwDesiredAccess ignored)
#define DUPLICATE_SAME_ACCESS 2

#define EXCEPTION_MAXIMUM_PARAMETERS 15 // maximum number of exception parameters

struct EXCEPTION_RECORD {
    DWORD  ExceptionCode;
    DWORD  ExceptionFlags;
    EXCEPTION_RECORD *ExceptionRecord;
    PVOID *ExceptionAddress;
    DWORD  NumberParameters;
    ULONG_PTR ExceptionInformation[EXCEPTION_MAXIMUM_PARAMETERS];
}
// ExceptionCode
#define EXCEPTION_ACCESS_VIOLATION          0xC0000005
#define EXCEPTION_DATATYPE_MISALIGNMENT     0x80000002
#define EXCEPTION_BREAKPOINT                0x80000003
#define EXCEPTION_SINGLE_STEP               0x80000004
#define EXCEPTION_ARRAY_BOUNDS_EXCEEDED     0xC000008C
#define EXCEPTION_FLT_DENORMAL_OPERAND      0xC000008D
#define EXCEPTION_FLT_DIVIDE_BY_ZERO        0xC000008E
#define EXCEPTION_FLT_INEXACT_RESULT        0xC000008F
#define EXCEPTION_FLT_INVALID_OPERATION     0xC0000090
#define EXCEPTION_FLT_OVERFLOW              0xC0000091
#define EXCEPTION_FLT_STACK_CHECK           0xC0000092
#define EXCEPTION_FLT_UNDERFLOW             0xC0000093
#define EXCEPTION_INT_DIVIDE_BY_ZERO        0xC0000094
#define EXCEPTION_INT_OVERFLOW              0xC0000095
#define EXCEPTION_PRIV_INSTRUCTION          0xC0000096
#define EXCEPTION_IN_PAGE_ERROR             0xC0000006
#define EXCEPTION_ILLEGAL_INSTRUCTION       0xC000001D
#define EXCEPTION_NONCONTINUABLE_EXCEPTION  0xC0000025
#define EXCEPTION_STACK_OVERFLOW            0xC00000FD
#define EXCEPTION_INVALID_DISPOSITION       0xC0000026
#define EXCEPTION_GUARD_PAGE                0x80000001
#define EXCEPTION_INVALID_HANDLE            0xC0000008
#define EXCEPTION_POSSIBLE_DEADLOCK         0xC0000194
// ExceptionFlags
#define EXCEPTION_NONCONTINUABLE      1 // Noncontinuable exception

// Define 128-bit 16-byte aligned xmm register type
struct M128A,2 {
    ULONGLONG Low;
    LONGLONG High;
}

// Format of data for 32-bit fxsave/fxrstor instructions.
struct XMM_SAVE_AREA32 {
    WORD   ControlWord;
    WORD   StatusWord;
    BYTE  TagWord;
    BYTE  Reserved1;
    WORD   ErrorOpcode;
    DWORD ErrorOffset;
    WORD   ErrorSelector;
    WORD   Reserved2;
    DWORD DataOffset;
    WORD   DataSelector;
    WORD   Reserved3;
    DWORD MxCsr;
    DWORD MxCsr_Mask;
    M128A FloatRegisters[8];
    M128A XmmRegisters[16];
    BYTE  Reserved4[96];
}

#define SIZE_OF_80387_REGISTERS 80
#define MAXIMUM_SUPPORTED_EXTENSION 512
struct FLOATING_SAVE_AREA {
    DWORD   ControlWord;
    DWORD   StatusWord;
    DWORD   TagWord;
    DWORD   ErrorOffset;
    DWORD   ErrorSelector;
    DWORD   DataOffset;
    DWORD   DataSelector;
    BYTE    RegisterArea[SIZE_OF_80387_REGISTERS];
    DWORD   Cr0NpxState;
}
struct CONTEXT {
    DWORD ContextFlags;	
    DWORD   Dr0;
    DWORD   Dr1;
    DWORD   Dr2;
    DWORD   Dr3;
    DWORD   Dr6;
    DWORD   Dr7;
    FLOATING_SAVE_AREA FloatSave;
    DWORD   SegGs;
    DWORD   SegFs;
    DWORD   SegEs;
    DWORD   SegDs;
    DWORD   Edi;
    DWORD   Esi;
    DWORD   Ebx;
    DWORD   Edx;
    DWORD   Ecx;
    DWORD   Eax;
    DWORD   Ebp;
    DWORD   Eip;
    DWORD   SegCs;
    DWORD   EFlags;
    DWORD   Esp;
    DWORD   SegSs;
    BYTE    ExtendedRegisters[MAXIMUM_SUPPORTED_EXTENSION]; 
}
/*
struct CONTEXT,4 {
    //
    // Register parameter home addresses.
    //
    // N.B. These fields are for convience - they could be used to extend the
    //      context record in the future.
    //
    int64 P1Home;
    int64 P2Home;
    int64 P3Home;
    int64 P4Home;
    int64 P5Home;
    int64 P6Home;
    //
    // Control flags.
    //
    DWORD ContextFlags;
    DWORD MxCsr;
    //
    // Segment Registers and processor flags.
    //
    WORD   SegCs;
    WORD   SegDs;
    WORD   SegEs;
    WORD   SegFs;
    WORD   SegGs;
    WORD   SegSs;
    DWORD EFlags;
    //
    // Debug registers
    //
    int64 Dr0;
    int64 Dr1;
    int64 Dr2;
    int64 Dr3;
    int64 Dr6;
    int64 Dr7;
    //
    // Integer registers.
    //
    int64 Rax;
    int64 Rcx;
    int64 Rdx;
    int64 Rbx;
    int64 Rsp;
    int64 Rbp;
    int64 Rsi;
    int64 Rdi;
    int64 R8;
    int64 R9;
    int64 R10;
    int64 R11;
    int64 R12;
    int64 R13;
    int64 R14;
    int64 R15;
    //
    // Program counter.
    //
    int64 Rip;
    //
    // Floating point state.
    //

//  union {
        XMM_SAVE_AREA32 FltSave[0];
//      struct {
            M128A Header[2];
            M128A Legacy[8];
            M128A Xmm0;
            M128A Xmm1;
            M128A Xmm2;
            M128A Xmm3;
            M128A Xmm4;
            M128A Xmm5;
            M128A Xmm6;
            M128A Xmm7;
            M128A Xmm8;
            M128A Xmm9;
            M128A Xmm10;
            M128A Xmm11;
            M128A Xmm12;
            M128A Xmm13;
            M128A Xmm14;
            M128A Xmm15;
//      };
//  };
    //
    // Vector registers.
    //
    M128A VectorRegister[26];
    int64 VectorControl;
    //
    // Special debug control registers.
    //
    int64 DebugControl;
    int64 LastBranchToRip;
    int64 LastBranchFromRip;
    int64 LastExceptionToRip;
    int64 LastExceptionFromRip;
}
*/
#define CONTEXT_i386    0x00010000    // this assumes that i386 and
#define CONTEXT_i486    0x00010000    // i486 have identical context records

// ContextFlags
#define CONTEXT_CONTROL         (CONTEXT_i386 | 0x00000001) // SS:SP, CS:IP, FLAGS, BP
#define CONTEXT_INTEGER         (CONTEXT_i386 | 0x00000002) // AX, BX, CX, DX, SI, DI
#define CONTEXT_SEGMENTS        (CONTEXT_i386 | 0x00000004) // DS, ES, FS, GS
#define CONTEXT_FLOATING_POINT  (CONTEXT_i386 | 0x00000008) // 387 state
#define CONTEXT_DEBUG_REGISTERS (CONTEXT_i386 | 0x00000010) // DB 0-3,6,7
#define CONTEXT_EXTENDED_REGISTERS  (CONTEXT_i386 | 0x00000020) // cpu specific extensions

struct LDT_ENTRY,1 {
    unsigned WORD    LimitLow;
    unsigned WORD    BaseLow;
//  union {
//      struct {
            unsigned byte    BaseMid;
            unsigned byte    Flags1;     // Declare as bytes to avoid alignment
            unsigned byte    Flags2;     // Problems.
            unsigned byte    BaseHi;
/*        } Bytes;
      struct {
            DWORD   BaseMid : 8;
            DWORD   Type : 5;
            DWORD   Dpl : 2;
            DWORD   Pres : 1;
            DWORD   LimitHi : 4;
            DWORD   Sys : 1;
            DWORD   Reserved_0 : 1;
            DWORD   Default_Big : 1;
            DWORD   Granularity : 1;
            DWORD   BaseHi : 8;
        } Bits;
    } HighWord;*/
}
//BaseLow | (BaseMid<<16) | (BaseHi<<24)

declare import, DebugActiveProcess(DWORD dwProcessId),BOOL;

declare import, GetThreadContext(HANDLE hThread, CONTEXT *lpContext),BOOL;
declare import, SetThreadContext(HANDLE hThread, CONTEXT *lpContext),BOOL;
declare import, GetThreadSelectorEntry(HANDLE hThread, DWORD dwSelector, LDT_ENTRY *lpSelectorEntry),BOOL;
declare import, WaitForDebugEvent(DEBUG_EVENT *lpDebugEvent, DWORD dwMilliseconds),BOOL;
declare import, ContinueDebugEvent(DWORD dwProcessId, DWORD dwThreadId, DWORD dwContinueStatus),BOOL;
// dwContinueStatus
#define DBG_CONTINUE              0x00010002
#define DBG_EXCEPTION_NOT_HANDLED 0x00010001


struct EXCEPTION_DEBUG_INFO {
    EXCEPTION_RECORD ExceptionRecord;
    DWORD dwFirstChance;
}

struct CREATE_THREAD_DEBUG_INFO {
    HANDLE  hThread;
    LPVOID *lpThreadLocalBase;
    THREAD_START_ROUTINE *lpStartAddress;
}

struct CREATE_PROCESS_DEBUG_INFO {
    HANDLE  hFile; // CloseHandle
    HANDLE  hProcess;
    HANDLE  hThread;
    LPVOID *lpBaseOfImage;
    DWORD   dwDebugInfoFileOffset;
    DWORD   nDebugInfoSize;
    LPVOID *lpThreadLocalBase;
    THREAD_START_ROUTINE *lpStartAddress;
    LPVOID *lpImageName;
    WORD fUnicode;
}

struct EXIT_THREAD_DEBUG_INFO {
    DWORD dwExitCode;
}

struct EXIT_PROCESS_DEBUG_INFO {
    DWORD dwExitCode;
}

struct LOAD_DLL_DEBUG_INFO {
    HANDLE  hFile; // CloseHandle
    LPVOID *lpBaseOfDll;
    DWORD   dwDebugInfoFileOffset;
    DWORD   nDebugInfoSize;
    LPVOID *lpImageName;
    WORD    fUnicode;
}

struct UNLOAD_DLL_DEBUG_INFO {
    LPVOID *lpBaseOfDll;
}

struct OUTPUT_DEBUG_STRING_INFO {
    LPSTR *lpDebugStringData;
    WORD   fUnicode;
    WORD   nDebugStringLength;
}

struct RIP_INFO {
    DWORD dwError;
    DWORD dwType;
}


struct DEBUG_EVENT {
    DWORD dwDebugEventCode;
    DWORD dwProcessId;
    DWORD dwThreadId;
//  union {
        CREATE_THREAD_DEBUG_INFO CreateThread[0];//12
        CREATE_PROCESS_DEBUG_INFO CreateProcessInfo[0];//40
        EXIT_THREAD_DEBUG_INFO ExitThread[0];//4
        EXIT_PROCESS_DEBUG_INFO ExitProcess[0];//4
        LOAD_DLL_DEBUG_INFO LoadDll[0];//24
        UNLOAD_DLL_DEBUG_INFO UnloadDll[0];//4
        OUTPUT_DEBUG_STRING_INFO DebugString[0];//8
        RIP_INFO RipInfo[0];//8
        EXCEPTION_DEBUG_INFO Exception[1];//84
//  } u;
}
// dwDebugEventCode
#define EXCEPTION_DEBUG_EVENT       1
#define CREATE_THREAD_DEBUG_EVENT   2
#define CREATE_PROCESS_DEBUG_EVENT  3
#define EXIT_THREAD_DEBUG_EVENT     4
#define EXIT_PROCESS_DEBUG_EVENT    5
#define LOAD_DLL_DEBUG_EVENT        6
#define UNLOAD_DLL_DEBUG_EVENT      7
#define OUTPUT_DEBUG_STRING_EVENT   8
#define RIP_EVENT                   9




declare import, GetModuleInformation(
  HANDLE hProcess,
  HMODULE hModule,
  MODULEINFO *lpmodinfo,
  DWORD cb
),BOOL;

struct MODULEINFO {
  LPVOID *lpBaseOfDll;
  DWORD   SizeOfImage;
  LPVOID *EntryPoint;
}

declare import, CreateProcess alias CreateProcessA(
  LPCTSTR *lpApplicationName,
  LPTSTR *lpCommandLine,
  SECURITY_ATTRIBUTES *lpProcessAttributes,
  SECURITY_ATTRIBUTES *lpThreadAttributes,
  BOOL bInheritHandles,
  DWORD dwCreationFlags,
  LPVOID *lpEnvironment,
  LPCTSTR *lpCurrentDirectory,
  STARTUPINFO *lpStartupInfo,
  PROCESS_INFORMATION *lpProcessInformation
),BOOL;

#define DEBUG_PROCESS                     0x00000001
#define DEBUG_ONLY_THIS_PROCESS           0x00000002
#define CREATE_SUSPENDED                  0x00000004
#define DETACHED_PROCESS                  0x00000008
#define CREATE_NEW_CONSOLE                0x00000010
#define NORMAL_PRIORITY_CLASS             0x00000020
#define IDLE_PRIORITY_CLASS               0x00000040
#define HIGH_PRIORITY_CLASS               0x00000080
#define REALTIME_PRIORITY_CLASS           0x00000100
#define CREATE_NEW_PROCESS_GROUP          0x00000200
#define CREATE_UNICODE_ENVIRONMENT        0x00000400
#define CREATE_SEPARATE_WOW_VDM           0x00000800
#define CREATE_SHARED_WOW_VDM             0x00001000
#define CREATE_FORCEDOS                   0x00002000
#define BELOW_NORMAL_PRIORITY_CLASS       0x00004000
#define ABOVE_NORMAL_PRIORITY_CLASS       0x00008000
#define STACK_SIZE_PARAM_IS_A_RESERVATION 0x00010000
#define CREATE_BREAKAWAY_FROM_JOB         0x01000000
#define CREATE_PRESERVE_CODE_AUTHZ_LEVEL  0x02000000
#define CREATE_DEFAULT_ERROR_MODE         0x04000000
#define CREATE_NO_WINDOW                  0x08000000
#define PROFILE_USER                      0x10000000
#define PROFILE_KERNEL                    0x20000000
#define PROFILE_SERVER                    0x40000000
#define CREATE_IGNORE_SYSTEM_DEFAULT      0x80000000
#define THREAD_PRIORITY_LOWEST          -2
#define THREAD_PRIORITY_BELOW_NORMAL    (-2+1)
#define THREAD_PRIORITY_NORMAL          0
#define THREAD_PRIORITY_HIGHEST         2
#define THREAD_PRIORITY_ABOVE_NORMAL    (2-1)
#define THREAD_PRIORITY_ERROR_RETURN    0x7FFFFFFF
#define THREAD_PRIORITY_TIME_CRITICAL   15
#define THREAD_PRIORITY_IDLE             -15
#define THREAD_ALL_ACCESS 0x1F03FF

CONST LOCALE_SYSTEM_DEFAULT = 0x1006;

declare import, OpenProcess(DWORD dwDesiredAccess,BOOL bInheritHandle,DWORD dwProcessId),HANDLE;
const PROCESS_ALL_ACCESS =  0x1F0FFF;

const PROCESS_CREATE_PROCESS = 128;
const PROCESS_CREATE_THREAD = 2;
const PROCESS_DUP_HANDLE = 64;
const PROCESS_QUERY_INFORMATION = 1024;
const PROCESS_SET_INFORMATION = 512;
const PROCESS_TERMINATE = 1;
const PROCESS_VM_OPERATION = 8;
const PROCESS_VM_READ = 16;
const PROCESS_VM_WRITE = 32;
const PROCESS_SET_QUOTA  =0x0100;

declare import, GetStartupInfo alias GetStartupInfoA(STARTUPINFO *lpStartupInfo);
declare import, SuspendThread(HANDLE hThread),DWORD;
declare import, ResumeThread(HANDLE hThread),DWORD;
declare import, GetModuleHandle alias GetModuleHandleA(LPCTSTR *lpModuleName),HMODULE;
declare import, GetProcAddress(HMODULE hModule,LPCSTR *lpProcName),FARPROC;

declare import, CreateToolhelp32Snapshot(DWORD dwFlags, DWORD th32ProcessID),HANDLE;
CONST TH32CS_INHERIT      = 0x80000000;
CONST TH32CS_SNAPHEAPLIST = 1;
CONST TH32CS_SNAPMODULE   = 8;
CONST TH32CS_SNAPPROCESS  = 2;
CONST TH32CS_SNAPTHREAD   = 4;
CONST TH32CS_SNAPALL      = 15;

CONST MAX_MODULE_NAME32 = 255;

struct PROCESSENTRY32
{
  DWORD dwSize;
  DWORD cntUsage;
  DWORD th32ProcessID;
  ULONG_PTR th32DefaultHeapID;
  DWORD th32ModuleID;
  DWORD cntThreads;
  DWORD th32ParentProcessID;
  LONG  pcPriClassBase;
  DWORD dwFlags;
  TCHAR szExeFile[MAX_PATH];
}

struct MODULEENTRY32
{
  DWORD dwSize;
  DWORD th32ModuleID;
  DWORD th32ProcessID;
  DWORD GlblcntUsage;
  DWORD ProccntUsage;
  BYTE* modBaseAddr;
  DWORD modBaseSize;
  HMODULE hModule;
  TCHAR szModule[MAX_MODULE_NAME32 + 1];
  TCHAR szExePath[MAX_PATH];
}

declare import, Process32First(HANDLE hSnapshot, PROCESSENTRY32 *lppe),BOOL;
declare import, Process32Next(HANDLE hSnapshot, PROCESSENTRY32 *lppe),BOOL;
declare import, Module32First(HANDLE hSnapshot, MODULEENTRY32 *lpme),BOOL;
declare import, Module32Next(HANDLE hSnapshot, MODULEENTRY32 *lpme),BOOL;


const STARTF_USESHOWWINDOW  = 0x1;
const STARTF_USESIZE   = 0x2;
const STARTF_USEPOSITION  = 0x4;
const STARTF_USECOUNTCHARS  = 0x8;
const STARTF_USEFILLATTRIBUTE = 0x10;
const STARTF_RUNFULLSCREEN  = 0x20;
const STARTF_FORCEONFEEDBACK = 0x40;
const STARTF_FORCEOFFFEEDBACK = 0x80;
const STARTF_USESTDHANDLES  = 0x100;
const STARTF_USEHOTKEY   = 0x200;

//security
declare import, LookupPrivilegeValue alias LookupPrivilegeValueA(
  LPCTSTR *lpSystemName,
  LPCTSTR *lpName,
  PLUID *lpLuid
),BOOL;

declare import, OpenProcessToken(
  HANDLE ProcessHandle,
  DWORD DesiredAccess,
  HANDLE *TokenHandle
),BOOL;

declare import, AdjustTokenPrivileges(
  HANDLE TokenHandle,
  BOOL DisableAllPrivileges,
  TOKEN_PRIVILEGES *NewState,
  DWORD BufferLength,
  TOKEN_PRIVILEGES *PreviousState,
  DWORD *ReturnLength
),BOOL;

#define TOKEN_QUERY 8
#define TOKEN_ADJUST_PRIVILEGES 0x20

struct LUID {
  DWORD LowPart;
  LONG HighPart;
}
struct LUID_AND_ATTRIBUTES {
  LUID Luid;
  DWORD Attributes;
}
struct TOKEN_PRIVILEGES {
  DWORD PrivilegeCount;
  LUID_AND_ATTRIBUTES Privileges[1];
}


//thread
declare import, CreateRemoteThread(HANDLE hProcess,SECURITY_ATTRIBUTES *lpThreadAttributes,SIZE_T dwStackSize,THREAD_START_ROUTINE *lpStartAddress,LPVOID *lpParameter,DWORD dwCreationFlags,DWORD *lpThreadId),HANDLE;
declare import, GetExitCodeThread(HANDLE hThread,DWORD *lpExitCode),BOOL;

//////////////////////////////////////////////////////////////////
//winsock


struct in_addr
{
	u_long  S_addr[0];
	u_short s_w1[0];
	u_char  s_b1;
	u_char  s_b2;
	u_short s_w2[0];
	u_char  s_b3;
	u_char  s_b4;
}


struct in6_addr
{
	u_short _Word[0];  //[8]
	u_char  _Byte[16];
}

struct sockaddr_in {
        short   sin_family;
        u_short sin_port;
        in_addr sin_addr;
        char    sin_zero[8];
}


struct sockaddr_in6 {
        short   sin6_family;
        u_short sin6_port;
        u_long  sin6_flowinfo;
        in6_addr sin6_addr;
        u_long  sin6_scope_id;
}


struct sockaddr_in6_old {
        short   sin6_family;        
        u_short sin6_port;          
        u_long  sin6_flowinfo;      
        in6_addr sin6_addr;  
}

struct IP_ADDR_STRING
{
  IP_ADDR_STRING *Next;
  dstring IpAddress[16];
  dstring IpMask[16];
  DWORD Context;
}
#define MAX_ADAPTER_NAME_LENGTH 256
#define MAX_ADAPTER_DESCRIPTION_LENGTH 128
#define MAX_ADAPTER_ADDRESS_LENGTH 8
#define MAX_HOSTNAME_LEN 128
#define MAX_DOMAIN_NAME_LEN 128
#define MAX_SCOPE_ID_LEN 256
#define ERROR_BUFFER_OVERFLOW 111

struct IP_ADAPTER_INFO
{
  IP_ADAPTER_INFO *Next;
  DWORD ComboIndex;
  dstring AdapterName[MAX_ADAPTER_NAME_LENGTH + 4];
  dstring Description[MAX_ADAPTER_DESCRIPTION_LENGTH + 4];
  UINT AddressLength;
  BYTE Address[MAX_ADAPTER_ADDRESS_LENGTH];
  DWORD Index;
  UINT Type;
  UINT DhcpEnabled;
  IP_ADDR_STRING *CurrentIpAddress;
  IP_ADDR_STRING IpAddressList;
  IP_ADDR_STRING GatewayList;
  IP_ADDR_STRING DhcpServer;
  BOOL HaveWins;
  IP_ADDR_STRING PrimaryWinsServer;
  IP_ADDR_STRING SecondaryWinsServer;
  time_t LeaseObtained;
  time_t LeaseExpires;
}

struct FIXED_INFO
{
  dstring HostName[MAX_HOSTNAME_LEN + 4];
  dstring DomainName[MAX_DOMAIN_NAME_LEN + 4];
  IP_ADDR_STRING *CurrentDnsServer;
  IP_ADDR_STRING DnsServerList;
  UINT NodeType;
  dstring ScopeId[MAX_SCOPE_ID_LEN + 4];
  UINT EnableRouting;
  UINT EnableProxy;
  UINT EnableDns;
}


declare import, GetAdaptersInfo(IP_ADAPTER_INFO *pAdapterInfo,ULONG *pOutBufLen),DWORD;
declare import, GetNetworkParams(FIXED_INFO pFixedInfo,ULONG *pOutBufLen),DWORD;

#endif
